CON
  _clkmode      = xtal1 + pll16x                        ' use crystal x 16
  _xinfreq      = 6_250_000                             ' 6.25Mhz crystal  
'  _xinfreq      = 5_000_000                             ' 5Mhz crystal
  deskBgFileN   = 1                                     ' Desktop background with icons always first file
  maskFileN     = 2                                     ' Mask file number for merging icons, always #2

var byte   desktop, mask
  
OBJ

'  tch:           "TouchSSD"                                ' touchscreen driver
  tch:           "Touch_v1_0_1963a.spin"                                ' touchscreen driver



PUB Main | wcboot ' warm or cold boot                                           ' Main Program - !First PUB method!
  wcboot := tch.BeginDesktop("7")                                               ' "I" = ILI9325, "S"= SSD1289                   ' erase ram chip, checks if a cold or warm boot, sets some variables 
    'tch.changeOrientation(false)
    if wcboot == false                                                          ' - cold boot -
      'desktop := tch.SDBMPtoRam(string("desktop.bmp"))                          ' Load file number 1, a 240x320 file called desktop.bmp\
      tch.RAMErase(1)
      desktop := tch.SDBMPtoRam(string("800.bmp"))
      DrawDesktop                                                               ' Draw 1'st file to (0,0)
      LoadDesktopCSV                                                            ' Load CSV file into ram
      DrawIcons                                                                 ' Merge icons into desktop background file
    else                                                                        ' - warm boot -
      tch.ManualValues                                                          ' coming from outside so reset ramsize and ramlocation values for 0 and 1
      DrawDesktop                                                               ' quick redraw of desktop if a warm boot
      LoadDesktopCSV                                                            ' Load CSV file into ram 
    tch.SelectSPIGroup                                                          ' selects this group and starts the cog
    tch.pause1ms(250)                                                            ' pause for a short time, helps prevent phantom press
    Touchscreen                                                                 ' wait for input

PUB TouchScreen  | val,v2 , pointer, x, y 

    tch.TouchPixel          ' throw the first set away
    tch.TouchPixel  
    repeat
      v2:= tch.TouchPixel
      val := tch.TouchPixel                                                 ' decode yval 0-100%
      if (val == v2)

        if (val <> $FFFF)                                                 ' if valid press
          x := val & $FFFF
          y :=  val >> 16
 '         tch.SetCursor(0,400)
 '         tch.hex(x, 3)
 '         tch.hex(y, 3)
          
          '' y is ? tall  800 / 13 = 60 pixels
          ''x is 8 wide = 480 / 8  = 60 pixels
            pointer := (y / 60) * 8 +  (x / 60)                         ' reduce to a value 0-19 so can read the correct string for the file name
             
          'tch.hex(ptr, 4)
          
'          pointer := (yval / 20) * 4 +(xval / 25)                         ' reduce to a value 0-19 so can read the correct string for the file name
          if pointer < 40                                                 ' there are spaces for 20 icons on the screen 4 wide 5 high
          '  tch.SetCursor(0,464)
          '  tch.hex(pointer, 2)
            tch.SelectMemGroup                                            ' prepare for ram access
            if (tch.StringCompare(pointer+120,163) <> 0)                              ' check if actually used                                              
              tch.StringJoin(165,pointer+120,161)                                      ' filename plus .exe
              tch.text(tch.stringrambuffer(165))
              tch.Clearscreen(tch.RGBtoWord(0,0,0))                                 ' so something happens straight away
              tch.Chain(tch.stringrambuffer(165))                                    ' run this filename
          '  else                                                                    ' blank
              tch.SelectSPIGroup                                                    ' selects this group and starts the cog

PUB DrawDesktop                  
   tch.DrawBMPRam(1,0,0)                                ' file number 1, location 0,0 . needs number, cant use variable due to flashBack

PUB LoadDesktopCSV | n                                  ' load the file desktop.csv (Excel csv file with icon locations)
   mask := tch.SDBMPtoRam(string("mask.bmp"))           ' file 2, load this here - if load after the strings get a white line on the icons          
   tch.StringDim(165)                                    ' file number 3 is all the strings
   tch.StringStore(160,string("desktop.csv"))            ' filename to load
   tch.StringLoadfile(160,0)                             ' load from 0 to 19 (20 lines of text in a desktop.csv file)
   repeat n from 0 to 39
     CutupComma(n)
   tch.StringStore(161,string(".exe"))                   ' store exe extension for later  
   tch.StringStore(162,string(".bmp"))                   ' store .bmp extension
   tch.StringStore(163,string("blank"))                  ' store for later
   ' array 0-39 are raw string, 40-79 are x, 80-119 are y, 120-159 are filename with no extension or "blank"

PUB DrawIcons | n,x,y, icon
   repeat n from 120 to 159                               ' draw the icons - mask alredy loaded in file 2 when loading desktop
     if tch.StringCompare(n,163) <> 0                    ' is this entry "blank"?
       tch.StringJoin(165,n,162)                          ' create filename.bmp
       x := tch.StringVal(n-80)                         ' need to pre-evaluate these, can't put in the mergebackground routine
       y := tch.StringVal(n-40)
    
       tch.MergeBackgroundIconRam(tch.stringrambuffer(165),x,y,desktop,mask)',icon)            ' desktop file 1, mask file 2, icons in file 4
       DrawDesktop                                                              ' update desktop icons

PUB CutupComma(Source) | c1,c2,len                      ' pass source 0-19, dest = 20-39 for first group, 40-59 for second group etc
   c1 := tch.StringInstr(Source,1,",")                  ' first comma
   c2 := tch.StringInstr(Source,c1+1,",")               ' second comma
   len := tch.StringLen(Source)                         ' length
   tch.StringLeft(Source+40,Source,c1-1)                ' first value
   tch.StringMid(Source+80,Source,c1+1,c2-c1-1)         ' second value
   tch.StringRight(Source+120,Source,len-c2)             ' third value = filename with no extension

       