{{
This is the extended RAM version
}}
PUB  NULL 'not a top level object

PUB LatchGroup4
    CogCmd("D",%00001111,%11110111,0)                            ' set all group pins high

PUB LatchGroup4High
    CogCmd("D",%00001111,%11111111,0)                            ' set all group pins high    

PUB Latch_DisplayL               ' display on the left
    CogCmd("D",%01001111,%11011101,0)                            ' set all group pins high

PUB Latch_DisplayR              ' display on the right
    CogCmd("D",%00101111,%10111101,0)                            ' set all group pins high

PUB Latch_DisplayB              ' both displays  for debugging
    CogCmd("D",%00001111,%10011101,0)                            ' set all group pins high
   
PUB LatchGroup1
    CogCmd("D",%00001111,%11111110,0)                            ' set all group pins high

PUB LatchGroup2
    CogCmd("D",%00001111,%11111101,0)                            ' set all group pins high
 
PUB LatchGroup3
    CogCmd("D",%00001111,%11111011,0)                            ' set all group pins high

PUB Latch_ResetLow
    CogCmd("A",%11101111,0,0)                           'set this one low    

PUB Latch_ResetHigh
    CogCmd("O",%00010000,0,0)          ' set this pin high
            
PUB Latch_RS_Low
    CogCmd("A",%01111111,0,0)                            'set this one low    

PUB Latch_RS_High
    CogCmd("O",%10000000,0,0)          ' set this pin high 

''
''
'' ************ RAM cog driver ***************
PUB start : err_
' Initialise the Drac Ram driver. No actual changes to ram as the read/write routines handle this
  command := "I"
  cog := 1 + cognew(@tbp2_start, @command)
  if cog == 0
    err_ := $FF                 ' error = no cog
  else
    repeat while command        ' driver cog sets =0 when done
    err_ := errx                ' driver cog sets =0 if no error, else xx = error code

PUB stop
   if cog
      cogstop(cog~ - 1)      

PUB CogCmd(command_, hub_address, ram_address, block_length) : err_| a,b
' Do the command: A-Z (I is reserved for Initialise)
  'dira := 0                     ' tristate all pins with the spin dira
  a := dira                     ' store the state of these and restore at the end 
'  b := outa
  DIRA &= %11111111_11100000_00000000_00000000 ' tristate all common pins that cog can change so no conflicts
  hubaddrs := hub_address       ' hub address start
  ramaddrs := ram_address       ' ram address start
  blocklen := block_length      ' block length
  command  := command_          ' must be last !!
' Wait for command to complete and get status
  repeat while command          ' driver cog sets =0 when done
  err_ := errx                  ' driver cog sets =0 if no error, else xx = error code
  dira := a                     ' restore dira and outa
'  outa := b

CON
'' Modified code from Cluso's triblade
'' commands to move blocks of data to the ILI9325 touchscreen display
' DoCmd(command_, hub_address, ram_address, block_length)
' I - initialise     
' S - Move data from hub to ram
' T - Move data from ram to hub
' U - Move data from ram to display
' V - Hub to display
' E - convert from .raw RGB to two byte ILI format RRRRRGGG_GGG_BBBBB
' F - convert from .bmp BGR format to two byte ILI format
' X - merge icon and background based on a mask
' Z - Set 161 pins. Returns in group 1
' O - logic Or with latchvalue
' A - logic And with latchvalue

' D  -logic Or hubaddrs with latchvalue logic And ramaddrs with latchvalue 


VAR

' communication params(5) between cog driver code - only "command" and "errx" are modified by the driver
   long  command, hubaddrs, ramaddrs, blocklen, errx, cog ' rendezvous between spin and assembly (can be used cog to cog)
'        command  = A to Z etc =0 when operation completed by cog
'        hubaddrs = hub address for data buffer
'        ramaddrs = ram address for data
'        blocklen = ram buffer length for data transfer
'        errx     = returns =0 (false=good), else <>0 (true & error code)
'        cog      = cog no of driver (set by spin start routine


DAT
'' +-----------------------------------------------------------------------------------------------+
'' | Touchblade 161 Ram Driver (with grateful acknowlegements to Cluso and Average Joe)            |
'' +-----------------------------------------------------------------------------------------------+
                        org     0
tbp2_start    ' setup the pointers to the hub command interface (saves execution time later
                                      '  +-- These instructions are overwritten as variables after start
comptr                  mov     comptr, par     ' -|  hub pointer to command                
hubptr                  mov     hubptr, par     '  |  hub pointer to hub address            
ramptr                  add     hubptr, #4      '  |  hub pointer to ram address            
lenptr                  mov     ramptr, par     '  |  hub pointer to length                 
errptr                  add     ramptr, #8      '  |  hub pointer to error status           
cmd                     mov     lenptr, par     '  |  command  I/R/W/G/P/Q                  
hubaddr                 add     lenptr, #12     '  |  hub address                           
ramaddr                 mov     errptr, par     '  |  ram address                           
len                     add     errptr, #16     '  |  length                                
err                     nop                     ' -+  error status returned (=0=false=good) 
' Initialise hardware tristates everything and read/write set the pins
init                    
                        and     dira,maskP0P20low       ' tristate the pins with the cog dira                           
                        or      outa,maskP22            ' pin 22 high
                        or      dira,maskP22            ' and now set as an output
                        mov     dirb, #$FF              ' latch all high          

done                    mov     err, #0                 ' reset err=false=good
                        mov     latchvalue, dirb        ' restore latch value
                        wrlong  err, errptr             ' status =0=false=good, else error x                                    1-2   'HUB SYNC
                        call    #set373                 ' Set latch to vaule prior to cog opperation                            3+7=10
                        and     dira,maskP0P20low       ' tristates all the common pins, leaves P22 as is though                11      
                        wrlong  zero, comptr            ' command =0 (done)                                                     12-13                       

getcmd                  rdlong  cmd, comptr     wz      ' command ?
              if_z      jmp     #getcmd                 ' not yet
' get values passed from spin
                        call    #get_values      ' get hubaddr,ramaddr,len and set control pins 
' decode command
                        cmp     cmd, #"S"       wz      ' hub to ram
              if_z      jmp     #pasmhubtoram           
                        cmp     cmd, #"T"       wz      ' ram to hub
              if_z      jmp     #pasmramtohub
                        cmp     cmd, #"U"       wz      ' ram to display
              if_z      jmp     #pasmramtodisplay
                        cmp     cmd, #"O"       wz      ' logical or hubaddr with pasm latchvalue
              if_z      jmp     #latch373_OR          
                        cmp     cmd, #"A"       wz      ' logical and hubaddr with pasm latchvalue
              if_z      jmp     #latch373_AND

                        cmp     cmd, #"D"       wz      ' 
              if_z      jmp     #latch373_AO
                        cmp     cmd, #"N"       wz      ' convert 3 byte .bmp format BGR to 2 byte ili format (same as E but order reversed) . write to ram!
              if_z      jmp     #bmptoram              
                        cmp     cmd, #"F"       wz      ' convert 3 byte .bmp format BGR to 2 byte ili format (same as E but order reversed)
              if_z      jmp     #bmptoiliformat
                        cmp     cmd, #"X"       wz      ' merge icon and background based on a mask
              if_z      jmp     #mergeicons
                        cmp     cmd, #"V"       wz      ' hub to display
              if_z      jmp     #pasmhubtodisplay
                        cmp     cmd, #"E"       wz      ' convert 3 byte .raw format to 2 byte .ili format - hub to hub
              if_z      jmp     #rawtoiliformat
                        cmp     cmd, #"I"       wz      ' init
              if_z      jmp     #init
                        cmp     cmd, #"Z"       wz      ' set the 161 counters
              if_z      jmp     #setcounters
              
                        mov     err, cmd                ' error = cmd (unknown command)
                        jmp     #done
' ----------------- common routines -------------------------------------                     instruction cycles                                                                                 
get_values              rdlong  hubaddr, hubptr         ' get hub address   and sync hub               1-2                      1-2      
                        mov     err, #5                 ' err=5                                         3                       3
                        mov     dirb, latchvalue        ' save old latch value for restore              4                       4
                        rdlong  ramaddr, ramptr         ' get ram address   '' in sync                 1-2                      5-6  
                        or      outa,maskP16P20         ' set control pins high                         3                       7
                        or      dira,maskP16P20         ' set control pins P16-P20 as outputs           4                       8
                        rdlong  len, lenptr             ' get length        '' in sync                 1-2                      9-10                                                         
get_values_ret          ret                              '' returns @ INS window                        3                       11

set373                  or      outa,maskP22            ' pin 22 high                                   1                       1
                        or      dira,#%1_11111111       ' enable pins 0-7 and 8 as outputs              2                       2
                        and     outa,maskP0P8low        ' P0-P7 low                                     3                       3
                        or      outa,latchvalue         ' send out the data                             4                       4
                        or      outa,maskP8             ' P8 high, clocks out data                      1                       5
                        andn    outa,maskP22            ' pin 22 low                                    2                       6
set373_ret              ret                             '' returns @ INS window                         3                       7

set161                  mov     latchvalue,#%11111110   ' group 1, displays all off                     1                       1 
                        call    #set373                 ' send out to the latch                        2-1                      2 +7
                        and     outa,maskP0P20low       ' %11111111_11100000_00000000_00000000          2                       10
                        or      dira,maskP0P20P29       ' %00100000_11100000_00000000_00000000          3                       11
                        cmp     ramaddr,maskP19   wc    ' check if we have extended address             4                       12
                        muxnc   outa, maskP29           ' and !mux onto p29                             1                       13
                        andn    ramaddr,maskP0P18low    ' mask off the low 19 bits                      2                       14                         
                        or      outa,ramaddr            ' send out ramaddr                              3                       15
                        or      outa,maskP20            ' P20 clock high                                4                       16
                        or      outa,maskP16P20         ' P16-P20 high                                  1                       17
                        andn    dira,maskP29            ' %1101_1111_1111_1111_1111_1111_1111_1111      2                       18  
set161_ret              ret                             '                                               3                       19
                           '' old set161 clocked +1. not sure how to fix this.
                             '' perhaps just re-compile??

set161and373            call    #set161                 ' pass ramaddr                                  1 +3                      1+19
                        mov     latchvalue,#%11111101   ' group 2                                       1                         20
                        call    #set373                 ' change to group 2                             2 +3                      21+7
set161and373_ret        ret                             '' returns @ INS window 29                      2                         28  

                       
' ------------------ single letter commands  -------------------------------------
' command T
pasmramtohub            call    #set161and373           ' set up the 161 counter and change to group 2
                        and     dira,maskP16P31         '%11111111_11111111_00000000_00000000 inputs
                        andn    outa,maskP16            ' memory /rd low
                        nop                             '                                               
ramtohub_loop           mov     data_16,ina             ' get the data                        3        
                        wrword  data_16,hubaddr         ' move data to hub                   1-2      
                        andn    outa,maskP20            ' clock 161 low                       3        
                        or      outa,maskP20            ' clock 161 high                      4        
                        add     hubaddr,#2              ' increment the hub address           1        
                        djnz    len,#ramtohub_loop      '                                     2
                        or      outa,maskP16            ' memory /rd high  
                        jmp     #done                  ' ' tristate pins and listen for command

' command S
pasmhubtoram            call    #set161and373           ' set up the 161 counter and then change to group 2
                        or      dira,maskP0P15          ' %00000000_00000000_11111111_11111111         ' data bus outputs
                        
hubtoram_loop           and     outa,maskP16P31         '%11111111_11111111_00000000_00000000       ' clear for output  2                 
                        rdword  data_16,hubaddr         ' get the word from hub                          1-2
                        or      outa,data_16            ' send out the byte to P0-P15                     3
                        andn    outa,maskP17            ' set mem write low                               4
                        add     hubaddr,#2              ' increment by 2 bytes = 1 word. Put this here for small delay while writes   1
                        or      outa,maskP17            ' mem write high                                  2
                        andn    outa,maskP20            ' clock 161 low                                   3
                        or      outa,maskP20            ' clock 161 high                                  4
                        djnz    len,#hubtoram_loop      ' loop this many times                            1
                        jmp     #done                   ' tristate pins and listen for command   

' command U                       
pasmramtodisplay        call    #set161
                        mov     latchvalue, dirb
                        call    #set373
                        and     dira,maskP16P31         ' %11111111_11111111_00000000_00000000 so prop pins 0-15 HiZ
                        andn    outa,maskP19            ' CS low  
                        andn    outa,maskP16            ' ram /rd low
                        nop
                        nop
ramtodisplay_loop       andn    outa,maskP18            ' ILI write low
                        or      outa,maskP18            ' ILI write high
                        andn    outa,maskP20            ' clock 161 low
                        or      outa,maskP20            ' clock 161 high
                        djnz    len,#ramtodisplay_loop
                        or      outa,maskP16            ' mem /rd high
                        or      outa,maskP19            ' CS high
                        jmp     #done

' command V    '' pasmhubtodisplay  - main loop is 2 hub windows.
pasmhubtodisplay                    
                        mov     latchvalue, dirb
                        call    #set373

                        andn    outa,maskP19            ' CS low
                        or      dira,maskP0P15          '%00000000_00000000_11111111_11111111
hubtodisplay_loop       and     outa,maskP16P31         '%11111111_11111111_00000000_00000000       ' clear for output           4        
                        rdword  data_16,hubaddr         ' get the word from hub                                                 1-2
                        or      outa,data_16            ' send out the byte to P0-P15                                            3
                        andn    outa,maskP18P19            ' ILI write low                                                          4
                        or      outa,maskP18P19            ' ILI write high                                                         1
                        add     hubaddr,#2              ' one word                                                               2
                        djnz    len,#hubtodisplay_loop  ' do this many times                                                     3
                        or      outa,maskP19            ' CS high
                        jmp     #done                   '      

bmptoram                call #set161and373 ' set up the 161 counter and then change to group 2            '' THIS BROKEN!!! have not debugged yet...

                        or      dira,maskP0P15          ' %00000000_00000000_11111111_11111111         ' data bus outputs
 :bmptoramloop          '' 7 group *4 instructions
                        rdbyte  blue,hubaddr            '' get blue                                     '' 1-2     1
                        add     hubaddr,#1              '  increment pointer                            '' 3
                        shr     blue,#3                 '  blue = 000BBBBB                              '' 4         
                        rdbyte  green,hubaddr           '' get green                                    '' 1-2     2
                        add     hubaddr,#1              '  increment pointer                            '' 3
                        shr     green,#2                '  00GGGGGG                                     '' 4        
                        rdbyte  red,hubaddr             '' get red                                      '' 1-2     3
                        add     hubaddr,#1              '  increment pointer                            '' 3                       
                        shr     red,#3                  ' 000RRRRR                                      '' 4                        
                        shl     red,#3                  ' RRRRR000                                      '' 1       4                 
                        mov     ilihigh, green          ' ilihigh = 00GGGGGG                            '' 2                        
                        shr     ilihigh, #3             ' ilihigh = 00000GGG                            '' 3                    
                        or      ilihigh, red            ' ilihigh = RRRRRGGG                            '' 4
                        shl     ilihigh, #8             '  outa is now upper 8 bits :                   '' 1       5
                        or      outa, ilihigh           '                                               '' 2                      
                        and     green,#%00000111        ' 00000GGG                                      '' 3
                        shl     green,#5                ' GGG00000                                      '' 4
                        or      green ,blue             ' ililow = GGGBBBBB   ''data16 is lowbyte       '' 1       6
                        or      outa, green             '                                               '' 2  
                        andn    outa,maskP17            ' set mem write low                             '' 3
                        andn    outa,maskP20            ' clock 161 low                                 '' 4
                        or      outa,maskP17            ' mem write high                                '' 1       7                                                                         
                        and     outa,maskP16P31         ' clear for output                              '' 2
                        or      outa,maskP20            ' clock 161 high                                '' 3
                        djnz    len,#:bmptoramloop      ' loop until done                               '' 4
                           
                        jmp     #done                   ' set pins to tristate

BMPtoILIformat          ' takes a .bmp 3 byte BBBBBBBB GGGGGGGG RRRRRRRR and converts to 2 byte RRRRRGGG GGGBBBBB
                        ' same as E above but BGR instead of RGB
                        ' pass hubaddr, ramaddr and len
                        ' hubaddr is source location, len is number of pixels
                        ' ramaddr is destination in hub (messy naming) and length is 2/3 of blocklength
                        'call    #get_values ' gets hubaddress, ramaddress and len (ignores ramaddress)
bmploop
                        rdbyte blue,hubaddr
                        add hubaddr,#1
                        rdbyte green,hubaddr
                        add hubaddr,#1
                        rdbyte red,hubaddr
                        add hubaddr,#1
                        call #rgbtoili
                        wrbyte ililow,ramaddr
                        add ramaddr,#1
                        wrbyte ilihigh,ramaddr
                        add ramaddr,#1
                        djnz    len,#bmploop            ' loop until done
                        
                        jmp     #done                   ' set pins to tristate


'command E
RawtoILIformat          ' takes a .raw 3 byte RRRRRRRR GGGGGGGG BBBBBBBB and converts to 2 byte RRRRRGGG GGGBBBBB
                        ' pass hubaddr, ramaddr and len
                        ' hubaddr is source location, len is number of pixels
                        ' ramaddr is destination in hub (messy naming) and length is 2/3 of blocklength
rawloop                 rdbyte red,hubaddr
                        add hubaddr,#1
                        
                        rdbyte green,hubaddr
                        add hubaddr,#1
                        
                        rdbyte blue,hubaddr
                        add hubaddr,#1
                        
                        call #rgbtoili   
                        wrbyte ililow,ramaddr
                        add ramaddr,#1
                        
                        wrbyte ilihigh,ramaddr
                        add ramaddr,#1
                        
                        djnz    len,#rawloop            ' loop until done 
                        jmp     #done                   ' set pins to tristate

RGBtoILI                ' pass red,green, blue, returns ililow and ilihigh
                        shr     red,#3                  ' 000RRRRR 
                        shl     red,#3                  ' RRRRR000 
                        shr     green,#2                ' 00GGGGGG
                        mov     ilihigh,green           ' ilihigh = 00GGGGGG
                        shr     ilihigh,#3              ' ilihigh = 00000GGG
                        or      ilihigh,red             ' ilihigh = RRRRRGGG
                        and     green,#%00000111        ' 00000GGG
                        shl     green,#5                ' GGG00000
                        mov     ililow,green            ' ililow = GGG00000
                        shr     blue,#3                 ' blue = 000BBBBB
                        or      ililow,blue             ' ililow = GGGBBBBB
RGBtoILI_ret            ret
                        
' **** command X *********************
MergeIcons                                              ' hubaddress, ramaddress,len which are used here as background,icon,mask
                        mov     pasm_n,#59              ' do a single row
mergeiconsloop          rdbyte  ililow,len              ' reuse ililow, so this is rdword mask,maskcounter
                        and     ililow,#%11111          ' mask off low 5 bits and use just the blue as this is a grayscale bitmap
                        rdword  red,hubaddr             ' reuse red, so actually this is rdword background,backgroundcounter                        
                        cmp     ililow,#%10000   wc     ' compare if >128 (ie mid level gray)
              if_c      jmp     #mergeskip
                        rdword  green,ramaddr           ' reuse green, so this is rdword iconpixel, iconpixelcounter 
                        wrword  green,hubaddr           ' if replace, then move icon pixel to the background     
mergeskip               add     hubaddr,#2
                        add     ramaddr,#2
                        add     len,#2
                        djnz    pasm_n,#mergeiconsloop            ' loop until done 
                        jmp     #done                   'set pins to tristate
                        
'' *** command Z **********    sets 161 latches, pass ramaddr
setcounters             call    #set161
                        jmp     #done
                        
'' *** command O - logical OR hubaddr with latchvalue and send out (set desired bits) ***
latch373_OR             or      dirb,hubaddr              
                        jmp     #done
                        
'' *** command A - logical AND hubaddr with latchvalue and send out (clear desired bits) ***
latch373_AND            and     dirb,hubaddr                          
                        jmp     #done

latch373_AO             or       dirb, hubaddr
                        and      dirb, ramaddr
                        jmp     #done

' variables
pasm_n                  long    0                                    ' general purpose value
data_16                 long    0                                    ' general purpose value
ililow                  long    0                                    ' low data byte 
ilihigh                 long    0                                    ' high data byte 
red                     long    0                                    ' red, green blue variables
green                   long    0
blue                    long    0
latchvalue              long    %00000000_00000000_00000000_00000000  ' current 373 value  

' constants
Zero                    long    %00000000_00000000_00000000_00000000 ' used in several places
maskP0P2low             long    %11111111_11111111_11111111_11111000 ' P0-P2 low
maskP0P20               long    %00000000_00011111_11111111_11111111 ' P0-P18 enabled for output plus P19,P20    
maskP0P18low            long    %11111111_11111000_00000000_00000000 ' P0-P18 low
maskP16                 long    %00000000_00000001_00000000_00000000 ' pin 16
maskP17                 long    %00000000_00000010_00000000_00000000 ' pin 17
maskP18                 long    %00000000_00000100_00000000_00000000 ' pin 18
maskP19                 long    %00000000_00001000_00000000_00000000 ' pin 19
maskP20                 long    %00000000_00010000_00000000_00000000 ' pin 20
maskP22                 long    %00000000_01000000_00000000_00000000 ' pin 22
maskP16P31              long    %11111111_11111111_00000000_00000000 ' pin 16 to pin 31
maskP0P15               long    %00000000_00000000_11111111_11111111 ' for masking words
maskP16P20              long    %00000000_00011111_00000000_00000000
maskP0P20low            long    %11111111_11100000_00000000_00000000 ' for returning all group pins HiZ
maskP16P17P20           long    %00000000_00010011_00000000_00000000
maskP0P8low             long    %11111111_11111111_11111110_00000000  ' P0-P7 low
maskP8                  long    %00000000_00000000_00000001_00000000  ' pin 8


maskP0P20P29low         long    %11011111_11100000_00000000_00000000 
maskP29                 long    %00100000_00000000_00000000_00000000
maskP0P20P29            long    %00100000_00011111_11111111_11111111


maskP18P19              long    %00000000_00001100_00000000_00000000

''res 169 ''longs left in cog!!
                fit     496
{
                        cmp     cmd, #"G"       wz      ' draw routine SSD1963
              if_z      jmp     #pasm_Draw_SSD1963
' ------------------ SSD1289  DRAW_ SETUP )IN PASM -------------------------------------
' ********** command D and G draw subroutines in pasm **************
''Does not work yet
pasm_Draw_SSD1963
                        or      outa,maskP16P20         ' P16-20 High
                        or      dira,maskP0P20          ' P0-20 outputs
                        mov     latchvalue, dirb        ' restore latch value                        
                        and     latchvalue,#%01111111   ' RS low
                        call    #set373                 ' set latch
                        
                        '' first register address, gets 2 arguments 
                        and     outa,maskP16P31         ' set P0-P15 to zero ready to OR
                        or      outa,#$2A               ' send out the command  0x2A             '                              
                        andn    outa,maskP18P19         ' ILI write low                                 
                        or      outa,maskP18P19         ' ILI write high                                
                        or      latchvalue,#%10000000   ' RS high                                        1
                        call    #set373                 ' set latch

                        '' first argument
                        rdword  data_16,hubaddr         ' get the word from hub                         1-2       'hub sync
                        add     hubaddr,#4              ' increment the address                          3
                        mov     pasm_n, data_16         ' copy to pasm_n
                        shr     pasm_n, #8              ' high 8 bits of word         
                        '' first 8 bits
                        and     outa,maskP16P31         ' set P0-P15 to zero ready to OR
                        or      outa,pasm_n             ' send out the data
                        andn    outa,maskP18P19         ' ILI write low
                        or      outa,maskP18P19         ' ILI write high
                        '' second 8 bits
                        and     data_16,#$FF            ' mask off low 8 bits
                        and     outa,maskP16P31         ' set P0-P15 to zero ready to OR
                        or      outa,data_16            ' send out the data
                        andn    outa,maskP18P19         ' ILI write low
                        or      outa,maskP18P19         ' ILI write high
                        
                        '' second argument
                        rdword  data_16,hubaddr         ' get next word                                 1-2
                        add     hubaddr,#4              ' and increment the address                      3
                        mov     pasm_n, data_16         ' copy to pasm_n 
                        shr     pasm_n, #8              ' high 8 bits of word
                        '' first 8 bits
                        and     outa,maskP16P31         ' set P0-P15 to zero ready to OR
                        or      outa,pasm_n             ' send out the data
                        andn    outa,maskP18P19         ' ILI write low
                        or      outa,maskP18P19         ' ILI write high
                        '' second 8 bits
                        and     data_16,#$FF            ' mask off low 8 bits
                        and     outa,maskP16P31         ' set P0-P15 to zero ready to OR
                        or      outa,data_16            ' send out the data
                        andn    outa,maskP18P19         ' ILI write low
                        or      outa,maskP18P19         ' ILI write high

                         '' second register
                        and     latchvalue,#%01111111   ' RS low
                        call    #set373                 ' set latch

                        and     outa,maskP16P31         ' set P0-P15 to zero ready to OR
                        or      outa,#$2B               ' send out the command  0x2B                            
                        andn    outa,maskP18P19         ' ILI write low                                 
                        or      outa,maskP18P19         ' ILI write high                                

                        or      latchvalue,#%10000000   ' RS high                                       1
                        call    #set373                 ' set latch

                        '' first argument
                        rdword  data_16,hubaddr         ' get the word from hub                         1-2       'hub sync
                        add     hubaddr,#4              ' increment the address                           3
                        mov     pasm_n, data_16         ' copy to pasm_n     
                        shr     pasm_n, #8              ' high 8 bits of word           
                        '' first 8 bits
                        and     outa,maskP16P31         ' set P0-P15 to zero ready to OR
                        or      outa,pasm_n             ' send out the data
                        andn    outa,maskP18P19         ' ILI write low
                        or      outa,maskP18P19         ' ILI write high
                        '' second 8 bits
                        and     data_16,#$FF            ' mask off low 8 bits
                        and     outa,maskP16P31         ' set P0-P15 to zero ready to OR
                        or      outa,data_16            ' send out the data
                        andn    outa,maskP18P19         ' ILI write low
                        or      outa,maskP18P19         ' ILI write high
                        
                        '' second argument
                        rdword  data_16,hubaddr         ' get next word                                 1-2
                        add     hubaddr,#4              ' and increment the address                      3
                        mov     pasm_n, data_16         ' copy to pasm_n 
                        shr     pasm_n, #8              ' high 8 bits of word 
                        '' first 8 bits
                        and     outa,maskP16P31         ' set P0-P15 to zero ready to OR
                        or      outa,pasm_n             ' send out the data
                        andn    outa,maskP18P19         ' ILI write low
                        or      outa,maskP18P19         ' ILI write high
                        '' second 8 bits
                        and     data_16,#$FF            ' mask off low 8 bits
                        and     outa,maskP16P31         ' set P0-P15 to zero ready to OR
                        or      outa,data_16            ' send out the data
                        andn    outa,maskP18P19         ' ILI write low
                        or      outa,maskP18P19         ' ILI write high

                        ''Prepare GDDR write
                        and     latchvalue,#%01111111   ' RS low                                        1
                        call    #set373                 ' set latch                                     2+7=9=1

                        and     outa,maskP16P31         ' set P0-P15 to zero ready to OR                2
                        or      outa,#$2C               ' send out the command  0x2C                             3
                        andn    outa,maskP18P19         ' ILI write low                                 4
                        or      outa,maskP18P19         ' ILI write high                                1

                        or      latchvalue,#%10000000   ' RS high                                       2
                        call    #set373                 ' set latch                                     3+7
                        
                        jmp     #done                   ' finished
}
                