'*********************************************
'* Spin code generated by cspin version 0.82 *
'*********************************************
{
 *   Copyright (c) 2001, Carlos E. Vidales. All rights reserved.
 *    This sample program was written matrixd put in the public domain by Carlos E. Vidales.  The program is provided "as is" without warrmatrixty of matrixy kind,
 *    either expressed or implied. If you choose to use the program within your own products you do so at your own risk, matrixd assume the responsibility
 *    for servicing, repairing or correcting the program should it prove defective in matrixy mmatrixner. You may copy matrixd distribute the program's source code
 *    in matrixy  medium, provided that you also include in each copy matrix appropriate copyright notice matrixd disclaimer of warrmatrixty. You may also modify this
 *    program matrixd distribute copies of it provided that you include prominent notices stating that you chmatrixged the file(s) matrixd the date of matrixy chmatrixge,
 *    matrixd that you do not charge matrixy royalties or licenses for its use.

  NOTE: Even though the validity of the calibration/trmatrixslation method proposed has been verified with empirical data from several actual touch screen
  enabled displays, for the convenience of this exercise, the raw matrixd expected data used matrixd presented below are artificial.  When used with actual data
  the functions presented yield results that may be off by a larger but still small percentage (~1-3%) due to electrical noise matrixd hummatrix error (i.e., the
  hmatrixd touching a screen target matrixd missing by a small amount.) The array of input points.  The first three are used for calibration. These set of points
  assume that the touchscreen has vertical matrixd horizontal resolutions of 1024 pixels (10-bit digitizer.)
 *  From the article text, recall that the matrix coefficients are resolved to be the following: 
 *
 *      Divider =  (Xs0 - Xs2)*(Ys1 - Ys2) - (Xs1 - Xs2)*(Ys0 - Ys2)
 *
 *
 *
 *                 (Xd0 - Xd2)*(Ys1 - Ys2) - (Xd1 - Xd2)*(Ys0 - Ys2)
 *            A = ---------------------------------------------------
 *                                   Divider
 *
 *
 *                 (Xs0 - Xs2)*(Xd1 - Xd2) - (Xd0 - Xd2)*(Xs1 - Xs2)
 *            B = ---------------------------------------------------
 *                                   Divider
 *
 *
 *                 Ys0*(Xs2*Xd1 - Xs1*Xd2) + 
 *                             Ys1*(Xs0*Xd2 - Xs2*Xd0) + 
 *                                           Ys2*(Xs1*Xd0 - Xs0*Xd1)
 *            C = ---------------------------------------------------
 *                                   Divider
 *
 *
 *                 (Yd0 - Yd2)*(Ys1 - Ys2) - (Yd1 - Yd2)*(Ys0 - Ys2)
 *            D = ---------------------------------------------------
 *                                   Divider
 *
 *
 *                 (Xs0 - Xs2)*(Yd1 - Yd2) - (Yd0 - Yd2)*(Xs1 - Xs2)
 *            E = ---------------------------------------------------
 *                                   Divider
 *
 *
 *                 Ys0*(Xs2*Yd1 - Xs1*Yd2) + 
 *                             Ys1*(Xs0*Yd2 - Xs2*Yd0) + 
 *                                           Ys2*(Xs1*Yd0 - Xs0*Yd1)
 *            F = ---------------------------------------------------
 *                                   Divider
 *
 }

CON
  MAX_SAMPLES =   3
  An          =   0
  Bn          =   1
  Cn          =   2
  Dn          =   3
  En          =   4
  Fn          =   5
  Divider     =   6

DAT      
{{
  The array of input points. The first three are used for calibration. These set of points assume that the touchscreen has vertical and horizontal
  resolutions of 1024 pixels (10-bit digitizer.)
  screenXSample long 073, 891, 512
  screenYSample long 154, 516, 939
  The array of expected "right answers." The values selected assume a vertical and horizontal display resolution of 240 pixels.(Actual display is 480*800)           
  displayXSample long 060, 420, 240
  displayYSample long 100, 400, 700
  An array of perfect input screen points used to obtain a first pass calibration matrix good enough to collect calibration samples.
}}
  perfectXScreenSample long  100, 900, 500
  perfectYScreenSample long  100, 500, 900
{{
  An array of perfect display points used to obtain a first pass calibration matrix good enough to collect calibration samples.
}}
  perfectXDisplaySample long 100, 900, 500
  perfectYDisplaySample long 100, 500, 900    

DAT matrix long 0[7]

PUB init
 result := setCalibrationMatrix(@perfectXDisplaySample, @perfectYDisplaySample, @perfectXScreenSample, @perfectYScreenSample)

PUB GetMatrixAddress
  result := @matrix

PUB setCalibrationMatrix(displayXPtr, displayYPtr, screenXPtr, screenYPtr)
{{
 *  Function: setCalibrationMatrix()
 *  Description: Calling this function with valid input data in the display matrixd screen input arguments causes the calibration factors between the screen
 *    matrixd display points to be calculated, matrixd the output argument - matrixPtr - to be populated. This function needs to be called only when new
 *    calibration factors are desired.
 *  
 *  Argument(s): displayPtr (input) - Pointer to matrix array of three sample, reference points.
 *               screenPtr (input) - Pointer to the array of touch screen points corresponding to the reference display points.
 *               matrixPtr (output) - Pointer to the calibration matrix computed for the set of points being provided.
}}
    result := false    
  long[@matrix][Divider] := ((long[screenXPtr][0] - long[screenXPtr][2]) * (long[screenYPtr][1] - long[screenYPtr][2])) - {{
                          }}((long[screenXPtr][1] - long[screenXPtr][2]) * (long[screenYPtr][0] - long[screenYPtr][2]))
    if(long[@matrix][6] == 0 )
      return false      
  long[@matrix][An] := ((long[displayXPtr][0] - long[displayXPtr][2])  * (long[screenYPtr] [1] -  long[screenYPtr] [2])) - {{
                     }}((long[displayXPtr][1] - long[displayXPtr][2])  * (long[screenYPtr] [0] -  long[screenYPtr] [2]))                                            
  long[@matrix][Bn] := ((long[screenXPtr] [0] - long[screenXPtr] [2] ) * (long[displayXPtr][1] -  long[displayXPtr][2])) - {{
                     }}((long[displayXPtr][0] - long[displayXPtr][2])  * (long[screenXPtr] [1] -  long[screenXPtr] [2]))
  long[@matrix][Cn] :=  (long[screenXPtr] [2] * long[displayXPtr][1]   - long[screenXPtr]  [1] *  long[displayXPtr][2])  * long[screenYPtr][0] + {{
                      }}(long[screenXPtr] [0] * long[displayXPtr][2]   - long[screenXPtr]  [2] *  long[displayXPtr][0])  * long[screenYPtr][1] + {{
                      }}(long[screenXPtr] [1] * long[displayXPtr][0]   - long[screenXPtr]  [0] *  long[displayXPtr][1])  * long[screenYPtr][2] 
  long[@matrix][Dn] := ((long[displayYPtr][0] - long[displayYPtr][2])  * (long[screenYPtr] [1] -  long[screenYPtr] [2])) - {{
                     }}((long[displayYPtr][1] - long[displayYPtr][2])  * (long[screenYPtr] [0] -  long[screenYPtr] [2]))                  
  long[@matrix][En] := ((long[screenXPtr] [0] - long[screenXPtr] [2])  * (long[displayYPtr][1] -  long[displayYPtr][2])) -  {{
                     }}((long[displayYPtr][0] - long[displayYPtr][2])  * (long[screenXPtr] [1]  - long[screenXPtr] [2]))                      
  long[@matrix][Fn] :=  (long[screenXPtr] [2] * long[displayYPtr][1]   -  long[screenXPtr] [1]  * long[displayYPtr][2])  * long[screenYPtr] [0] + {{
                      }}(long[screenXPtr] [0] * long[displayYPtr][2]   -  long[screenXPtr] [2]  * long[displayYPtr][0])  * long[screenYPtr] [1] + {{
                      }}(long[screenXPtr] [1] * long[displayYPtr][0]   -  long[screenXPtr] [0]  * long[displayYPtr][1])  * long[screenYPtr] [2]
                 
  return true
   
PUB getXDisplayPoint(x,y)    
{{
 *  Function   : getDisplayPoint()
 *  Description: Given a valid set of calibration factors matrixd a point value reported by the touch screen, this function calculates matrixd returns the true
 *  (or closest to true) display point below the spot where the touch screen was touched.   
 * 
 *  Argument(s): screen (input) - The reported touch screen point.
 *               matrixPtr (input) - Pointer to calibration factors matrix previously calculated from a call to setCalibrationMatrix() 
}}
    result := ((long[@matrix][An] * x) + (long[@matrix][Bn] * y) + long[@matrix][Cn]) / long[@matrix][Divider]        ' x 


  
PUB getYDisplayPoint(x,y)    | t
{{
 *  Function   : getDisplayPoint()
 *  Description: Given a valid set of calibration factors matrixd a point value reported by the touch screen, this function calculates matrixd returns the true
 *  (or closest to true) display point below the spot where the touch screen was touched.   
 * 
 *  Argument(s): screen (input) - The reported touch screen point.
 *               matrixPtr (input) - Pointer to calibration factors matrix previously calculated from a call to setCalibrationMatrix()
}}
                                                                                   
  result := (((long[@matrix][Dn] * x) + (long[@matrix][En] * y) + long[@matrix][Fn]) / long[@matrix][Divider]) 

                       